config/routes.rb
Rails.application.routes.draw do

  get 'card/index'
  get 'card/all'
  get 'card/new'
  get 'card/edit' => 'card#edit'
  put 'card/edit' => 'card#update'
  delete 'card/destroy'
  post 'user/create'
  get 'user/view'
  get 'session/create'
  delete 'session/destroy'
  get 'deck/index'
  post 'deck/create'
  get 'deck/all'
  get 'deck/where'
  delete 'deck/destroy'
  get 'deck/edit' => 'deck#edit'
  put 'deck/edit' => 'deck#update'
  post 'session/logged_in' => 'session#logged_in'
  get 'deck/create' => 'deck#createView'
  post 'card/view', to: 'card#create', as: 'card_create'
  get 'card/view', to: 'card#view', as: 'card_view'


  root 'session#create'

  # Define your application routes per the DSL in https://guides.rubyonrails.org/routing.html

  # Defines the root path route ("/")
  # root "articles#index"
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  primary_abstract_class
end

app/models/card.rb
class Card < ApplicationRecord
  belongs_to :deck
end

app/models/deck.rb
class Deck < ApplicationRecord
  has_many :cards, dependent: :destroy
end

app/models/token.rb
class Token < ApplicationRecord
  belongs_to :user
  def authenticate_token(t)
    t == token
  end
end

app/models/user.rb
class User < ApplicationRecord

  def authenticate(pass)
    pass == password
  end
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base



end

app/controllers/card_controller.rb
# This controller is responsible for handling all the requests related to cards.
# It contains the following methods:
# 1. create
# 2. view
# 3. index
# 4. all
# 5. new
# 6. destroy
class CardController < ApplicationController
  include AuthenticationConcern

  def create

    @token = session[:token]
    # user_id = params[:authorization][0][:user_id]
    deck_id = params[:deck_ids]
    question = params[:question]
    description = params[:description]
    @card = Card.new
    @card.question = question
    @card.description = description
    @card.deck_id = params[:deck_ids]
    @card.save
  end

  def view
    @deckid = params[:deck_ids]
    render('card/create')
  end

  def index
    @token = session[:token]
    @deckid = params[:deck_ids]
    @cards = Card.where(deck_id: @deckid)
    render('card/index')
  end

  def all
    @token = session[:token]
    @deckid = params[:deck_ids]
    @cards = Card.joins(:deck).where(decks: {user_id: params[:authorization][0][:user_id]}).all
    render('card/all')
  end

  def edit
    @card = Card.find(params[:id])
    @card_id = params[:id]
    render('card/edit')
  end

  def update
    @card = Card.find(params[:id])
    @card.update(question: params[:question], description: params[:description])
    redirect_back(fallback_location: deck_all_path)
  end
  def new
  end

  def destroy
    @cards = Card.joins(:deck).where(decks: {user_id: params[:authorization][0][:user_id]}).all
    Card.destroy(params[:id])
    render('card/all')
  end
end

app/controllers/concerns/authenticationConcern.rb
require_relative '../../../lib/json_web_token'


# this module is used to add the authorization header to the params
# this module is used in the controllers that need to access the authorization header
# this module is included in the application controller
module AuthenticationConcern
  extend ActiveSupport::Concern
  attr_accessor :authorization

  # add the before_action to the controller
  # this will run the add_auth_header_to_params method before any action in the controller
  included do
    before_action :add_auth_header_to_params
  end

  # add the authorization header to the params
  # if the authorization header is not present, return a 400 error
  # if the authorization header is not in the correct format, return a 400 error
  # if the authorization header is in the correct format, decode the token and add it to the params
  def add_auth_header_to_params
    @token = session[:token]
    bearer_token = @token
    request.headers['Authorization'] = "Bearer #{bearer_token}" if bearer_token.present?
    if !request.headers['Authorization'].present?
      render status: 400, json: {message: 'No token provided'}
      return
    elsif request.headers['Authorization'].split(' ').length != 2
      render status: 400, json: {message: 'Invalid token for authorization'}
      return
    end

    auth_header = request.headers['Authorization'].split(' ')
    jwt = JsonWebToken.decode(auth_header[1]) if auth_header[0] == 'Bearer'
    params[:authorization] = jwt

  end

end

app/controllers/deck_controller.rb
# Deck Controller
# This controller is responsible for handling all requests related to decks.
# It contains the following methods:
# 1. index
# 2. createView
# 3. create
# 4. all
# 5. where
# 6. destroy
# 7. update
class DeckController < ApplicationController
  helper_method :all
  include AuthenticationConcern

  def index
    @deck = Deck.where(user_id: params[:authorization][0][:user_id])
  end

  def createView
    @token = session[:token]
    render 'deck/create'
  end

  def create
    @token = session[:token]
    user_id = params[:authorization][0][:user_id]
    @deck = Deck.new
    @deck.name = params[:Deck_name]
    @deck.description = params[:Deck_description]
    @deck.user_id = user_id
    @deck.save
  end

  def all
    @token = session[:token]
    user_id = params[:authorization][0][:user_id]
    @deck = Deck.where(user_id: user_id)
    render 'deck/all'
  end

  def update
    @deck = Deck.find(params[:id])
    @deck.update(name: params[:Deck_name], description: params[:Deck_description])
    redirect_back(fallback_location: deck_all_path)
  end
  def edit
    @deck = Deck.find(params[:id])
    @deck_id = params[:id]
    render('deck/edit')
  end

  def where
  end

  def destroy
    Deck.destroy(params[:id])
    render('deck/all')
  end

end

app/controllers/session_controller.rb
require_relative '../../lib/json_web_token'

# Session Controller
# This controller is responsible for handling all requests related to sessions.
# It contains the following methods:
# 1. create
# 2. logged_in
# 3. destroy
class SessionController < ApplicationController

  def create

    render 'session/create'

    # user = User.where(username: params[:username]).first
    # if user&.authenticate(params[:password])
    #   if (tok = Token.where(user_id: user.id).first)
    #     puts "Deleting token #{tok.token}"
    #     tok.delete
    #   end
    #   random = SecureRandom.hex(32)
    #   token_value = JsonWebToken.encode({user_id: user.id, account_type: user.account_type, random: random})
    #   token = Token.create(token: token_value, user_id: user.id)
    #   render status: 201, json: {message: 'User logged in successfully', token: token.token, id: user.id, username: user.username, account_type: user.account_type}
    # else
    #   render status: 401, json: {message: 'Invalid email'}
    # end
  end

  def logged_in
    puts 'logged_in'
    @email = params[:email].downcase
    user = User.where(email: params[:email]).first
    if user&.authenticate(params[:password])
      if (tok = Token.where(user_id: user.id).first)
        puts "Deleting token #{tok.token}"
        tok.delete
      end
      token_value = JsonWebToken.encode({user_id: user.id, email: user.email})
      token = Token.create(token: token_value, user_id: user.id)
      @token = token.token
      @@token = @token
      session[:token] = @token
      @deck = Deck.all
      render 'deck/all'
    else
      render status: 401, json: {message: 'Invalid email'}
    end
  end



  def destroy
    token = Token.where(token: session[:token]).first
    token&.delete
    session[:token] = nil
    redirect_to root_path
    ##### should add a check to see if the token is already deleted
  end
end

app/controllers/user_controller.rb
# Users controller
# This controller is responsible for handling all requests related to users.
# It contains the following methods:
# 1. create
# 2. view
class UserController < ApplicationController
  def create
    @user = User.new
    @user.email = params[:email].downcase
    @user.password = params[:password]
    @user.save
  end
  def view
    render 'user/create'
  end
  def destroy
  end

  def index
  end


end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/card_helper.rb
module CardHelper
end

app/helpers/deck_helper.rb
module DeckHelper
end

app/helpers/session_helper.rb
module SessionHelper
end

app/helpers/user_helper.rb
module UserHelper
end

app/views/card/all.html.erb
<%= render 'layouts/nav' %>
<h1></h1>
<% @cards.each do |card|  %>
  <table>
    <thead>Card ID: <%= card['id'] %> </thead>
    <tbody>Card Question: <%= card['question'] %> </tbody>
    <tbody>Card Answer: <%= card['id'] %> </tbody>
    <tbody><%= button_to "Delete", card_destroy_path, params: [id: card['id']], method: :delete %></tbody>
    <tbody><%= button_to "Edit", card_edit_path, params: [id: card['id']], method: :get %></tbody>
  </table>
  <br />
<% end %>

app/views/card/create.html.erb
<%= render 'layouts/nav' %>
<p>Create your flashcard for <%= Deck.where(id: @deckid).pluck(:name).first %></p>

<%= form_with  path: card_create_path, method: :post do |form| %>
  <%= hidden_field_tag :authenticity_token, form_authenticity_token %>
  <%= hidden_field_tag :deck_ids, @deckid %>
  <%= form.label :question, "Question" %>
  <%= form.text_field :question %>
  <%= form.label :description, "answer" %>
  <%= form.text_field :description %>
  <%= form.submit "Create" %>
<% end %>

app/views/card/destroy.html.erb
<h1>Card#destroy</h1>
<p>Find me in app/views/card/destroy.html.erb</p>

app/views/card/edit.html.erb
<p><%= @card['question'] %></p> <p><%= @card['description'] %></p>
<%= form_with  path: '/card/update', method: :put do |form| %>
  <%= hidden_field_tag :authenticity_token, form_authenticity_token %>
  <%= hidden_field_tag :id, @card_id %>
  <%= form.label :question, "Question" %>
  <%= form.text_field :question %>
  <%= form.label :description, "answer" %>
  <%= form.text_field :description %>
  <%= form.submit "Update" %>
<% end %>

app/views/card/index.html.erb
<%= render 'layouts/nav' %>

<% @cards.each do |card|  %>
  <table>
    <tbody>Card Question: <%= card['question'] %></tbody>
    <tbody><%= button_tag "Hide/Show", :onclick => "hideInput(#{card['id']})" %> </tbody>
    <div id="answer<%=card['id'] %>" style="display:none;">
      <p>Card Answer: <%= card['description'] %></p>
      <br />
    </div>
  </table>
  <!-- This is to make the button work. It's a javascript function that hides and shows the answer div. so you can study and guess the answer and then check it.
   /-->
  <script>
      function hideInput(cardId) {
          let emailDiv = document.getElementById(`answer${cardId}`);
          emailDiv.style.display === "inline" ?  emailDiv.style.display = 'none' : emailDiv.style.display = 'inline';
      }
  </script>
<% end %>

app/views/card/new.html.erb
<h1>Card#new</h1>
<p>Find me in app/views/card/new.html.erb</p>

app/views/deck/all.html.erb
<%= render 'layouts/nav' %>
<h1>Deck#all</h1>
<%= link_to "Create Deck", deck_create_path%>
<% if @deck != nil %>
  <% @deck.each do |decks|%>
    <p>Deck number: <%=decks['id'] %>
    Deck name: <%= decks['name'] %> -
    Deck Description: <%= decks['description'] %> -
    User id: <%= decks['user_id'] %></p>
    <p>
      <div class="buttonsForDeck">
        <%= button_to "Create", card_view_path, params: [deck_ids: decks['id']], method: :get %>
        <%= button_to "View Questions", card_index_path, params: [deck_ids: decks['id']], method: :get %>
        <%= button_to "View all cards", card_all_path, params: [id: decks['id']], method: :get %>
        <%= button_to "Edit Deck", deck_edit_path, params: [id: decks['id']], method: :get %>
        <div class="buttonDelete"><%= button_to "Delete Deck", deck_destroy_path, params: [id: decks['id']], method: :delete %></div>
      </div>
    </p>
    <p></p>
  <% end %>


  <% else %>
    <p>no decks</p>

<% end %>

app/views/deck/create.html.erb
<%= render 'layouts/nav' %>
<h1>Deck#create</h1>
<p>Find me in app/views/deck/create.html.erb</p>
<%= form_with url: "../deck/create", method: :post do |form|%>
  <%= hidden_field_tag :authenticity_token, form_authenticity_token %>
  <%= form.label :Deck_name, "Deck" %>
  <%= form.text_field :Deck_name %>
  <%= form.label :Deck_description, "Deck Description" %>
  <%= form.text_field :Deck_description %>

  <%= form.submit %>
<% end %>

app/views/deck/destroy.html.erb
<h1>Deck#destroy</h1>
<p>Find me in app/views/deck/destroy.html.erb</p>

app/views/deck/edit.html.erb
<p><%= @deck['name'] %></p> <p><%= @deck['description'] %></p>
<%= form_with  path: '/deck/update', method: :put do |form| %>
  <%= hidden_field_tag :authenticity_token, form_authenticity_token %>
  <%= hidden_field_tag :id, @deck_id %>
  <%= form.label :name, "Name" %>
  <%= form.text_field :name %>
  <%= form.label :description, "answer" %>
  <%= form.text_field :description %>
  <%= form.submit "Update" %>
<% end %>
<%= button_to 'Back', :back, method: :get %>

app/views/deck/index.html.erb
<h1>Deck#index</h1>
<p>Find me in app/views/deck/index.html.erb</p>

app/views/deck/update.html.erb
<h1>Deck#update</h1>
<p>Find me in app/views/deck/update.html.erb</p>

app/views/deck/where.html.erb
<h1>Deck#where</h1>
<p>Find me in app/views/deck/where.html.erb</p>

app/views/layouts/_nav.erb
<span>
  <table>

    <% if session[:token] != nil %>
      <tbody><%= button_to "All Deck", deck_all_path, method: :get %></tbody>
      <tbody><%= button_to "All Cards", card_all_path, method: :get %></tbody>
      <tbody><%= button_to "Logout", session_destroy_path, method: :delete %></tbody>
    <% else %>
      <tbody><%= button_to "Login", root_path, method: :get %></tbody>
    <% end %>

  </table>
</span>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Project3</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag "application", "data-turbo-track": "reload" %>
  </head>

  <body>
    <%= yield %>

  </body>
</html>

app/views/session/create.html.erb
<h1>Session#create</h1>
<p>Find me in app/views/session/create.html.erb</p>
<%= form_with url: "session/logged_in", method: :post do |form| %>
  <%= hidden_field_tag :authenticity_token, form_authenticity_token %>
  <%= form.label :email, "Username"%>
  <%= form.text_field :email %>
  <%= form.label :password, "Password" %>
  <%= form.password_field :password %>
  <%= form.submit "Login" %>
<% end %>
<p>You need to sign up? <%= link_to "Signup", user_view_path %> </p>

app/views/session/destroy.html.erb
<h1>Session#destroy</h1>
<p>Find me in app/views/session/destroy.html.erb</p>

app/views/user/create.html.erb
<%= render 'layouts/nav' %>
<h1>User#create</h1>
<%= form_with url: "create", method: :post do |form| %>
  <%= hidden_field_tag :authenticity_token, form_authenticity_token %>
  <%= form.label :email, "Email" %>
  <%= form.text_field :email %>
  <%= form.label :password, "Password" %>
  <%= form.password_field :password %>
  <%= form.submit "Sign up" %>
<% end %>

app/views/user/destroy.html.erb
<h1>User#destroy</h1>
<p>Find me in app/views/user/destroy.html.erb</p>

app/views/user/index.html.erb
<h1>User#index</h1>
<p>Find me in app/views/user/index.html.erb</p>